<i18n>
{
  "fr": {
    "title-1": "Année civile du BGES et budget du laboratoire",
    "title-2": "Effectif du laboratoire",
    "save-msg": "Les informations de périmètre ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>.",
    "info-1": "L’année considérée est celle des données utilisées, et non celle de l’établissement du BGES (par exemple les données que vous allez saisir dans l’outil datent de",
    "info-2": "et le BGES est construit en",
    "info-3": ": l’année du BGES est donc",
    "info-4": "Plus précisément, c’est l’année civile des données collectées pour les consommations d’énergie des bâtiments et, dans la mesure du possible, pour les déplacements en mission.",
    "info-5": "Il est possible que les données de consommations d’énergie des bâtiments ne soient pas disponibles pour la même année que celles des déplacements en missions. Faites au mieux! L’empreinte carbone d’un laboratoire est dans tous les cas un ordre de grandeur.",
    "info-6": "Indiquez l'ordre de grandeur des dépenses totales de votre laboratoire (dépenses de fonctionnement + dépenses d'investissements), y compris celles liées à des contrats, hormis les salaires quels qu'ils soient (salaires des permanents et salaires des personnels contractuels).",
    "info-7": "Une personne doit être comptée dans l’effectif du laboratoire seulement si elle a fait partie de l’effectif du laboratoire sur les 12 mois de l’année considérée (ceci exclut les stagiaires et les personnes visitantes qui restent moins d’un an).",
    "info-8": "Saisissez l’effectif relatif à l’année civile du BGES, ou à défaut, celui de l’année en cours. Ne pas inclure les chercheur.e.s associé.e.s.",
    "field-1": "Année civile du BGES",
    "field-2": "Budget annuel"
  },
  "en": {
    "title-1": "Calendar year of the GHG inventory and budget of the laboratory ",
    "title-2": "Headcount of the laboratory",
    "save-msg": "The data relating to the boundaries have been <strong><span style='color:green;'>successfully</span></strong>saved.",
    "info-1": "The year considered is that of the data, not that of the year when you conduct the GHG inventory (e.g. the data that you will enter into the tool date back to",
    "info-2": "and the GHG inventory is conducted in",
    "info-3": ": the year of the GHG inventory is",
    "info-4": "More precisely, it is the calendar year of the data collected for the energy consumption of the buildings, and, as much as possible, for the business trips.",
    "info-5": "It is possible that the data of the energy consumption of the buildings are not available for the same year as the business trips. Do the best you can ! In any case, the carbon footprint of a laboratory is an order-of-magnitude estimate.",
    "info-6": "Enter the order of magnitude of all the expenses of your laboratory (operating expenses + capital expenses), including those linked to contracts, excluding all salaries whatever they may be (salaries from permanent or temporary employees).",
    "info-7": "A person must be included in the headcount of the laboratory if he/she has been a member of the staff over the 12 months of the year considered  (this excludes interns and visiting persons who stayed less than a year).",
    "info-8": "Enter the headcount relating to the calendar year of the GHG inventory, or, if missing, that of the current year. Do not include associated researchers.",
    "field-1": "Calendar year of the GHG inventory",
    "field-2": "Annual budget"
  }
}
</i18n>

<template>
  <div>
    <serveur-info :erreur="module.erreur" />
    <form @submit.prevent="validateBeforeSubmit">
      <su-service :icon="'calendar'">
        <template #title>
          {{ $t('title-1') }}
        </template>
        {{ $t('info-1') }} {{ currentYear - 2 }} {{ $t('info-2') }} {{ currentYear }}{{ $t('info-3') }} {{ currentYear - 2 }}).
        <br />
        {{ $t('info-4') }}
        <br />
        {{ $t('info-5') }}
        <br />
        <br />
        {{ $t('info-6') }}
        <br />
        <br />
        <div class="columns">
          <div class="column">
            <b-field
              :label="$t('field-1') + ' *'"
              :type="{'is-danger': errors.has('year')}"
              :message="errors.first('year')">
              <b-select
                :placeholder="$t('field-1') + ' *'"
                icon="calendar"
                v-validate="'required'"
                name="year"
                expanded
                :disabled="submitted"
                v-model="year"
              >
                <option
                  :disabled="year.disabled"
                  v-for="(year,index) in availableYears"
                  :value="year.value"
                  :key="index">
                  {{ year.value }}
                </option>
              </b-select>
            </b-field>
          </div>
          <div class="column">
            <b-field
              :label="$t('field-2') + ' *'"
              :type="{'is-danger': errors.has('budget')}"
              :message="errors.first('budget')">
              <b-input
                name="budget"
                :placeholder="$t('field-2') + ' *'"
                v-model="budget"
                icon="eur"
                :disabled="submitted"
                v-validate="'required|numeric|min_value:1'"
              ></b-input>
            </b-field>
          </div>
        </div>
      </su-service>
      <br />
      <su-service :icon="'group'">
        <template #title>
          {{ $t('title-2') }}
        </template>
        {{ $t('info-7') }}
        <br />
        {{ $t('info-8') }}
        <br />
        <br />
        <div class="columns">
          <div class="column">
            <b-field
              :label="'# ' + $t('researchers')"
              :type="{'is-danger': errors.has('nResearcher')}"
              :message="errors.first('nResearcher')">
              <b-input
                name="nResearcher"
                :disabled="submitted"
                v-model="nResearcher"
                v-validate="'required|numeric'"
              ></b-input>
            </b-field>
          </div>
          <div class="column">
            <b-field
              :label="'# ' + $t('professors')"
              :type="{'is-danger': errors.has('nProfessor')}"
              :message="errors.first('nProfessor')">
              <b-input
                name="nProfessor"
                :disabled="submitted"
                v-model="nProfessor"
                v-validate="'required|numeric'"
              ></b-input>
            </b-field>
          </div>
          <div class="column">
            <b-field
              :label="'# ' + $t('engineers')"
              :type="{'is-danger': errors.has('nEngineer')}"
              :message="errors.first('nEngineer')">
              <b-input
                name="nEngineer"
                :disabled="submitted"
                v-model="nEngineer"
                v-validate="'required|numeric'"
              ></b-input>
            </b-field>
          </div>
          <div class="column">
            <b-field
              :label="'# ' + $t('students')"
              :type="{'is-danger': errors.has('nStudent')}"
              :message="errors.first('nStudent')">
              <b-input
                name="nStudent"
                :disabled="submitted"
                v-model="nStudent"
                v-validate="'required|numeric'"
              ></b-input>
            </b-field>
          </div>
          <div class="column">
            <b-field  label="# Total">
              <b-input
                disabled
                v-model="nbTotal"
              ></b-input>
            </b-field>
          </div>
        </div>
      </su-service>
      <br />
      <nav v-if="!submitted" class="level">
        <div class="level-left"></div>
        <div class="level-right">
          <button
            type="submit"
            :disabled="isDisabled"
            class="level-item button is-primary"
          >
            <span class="icon is-small" v-if="isAuthenticated"><i class="sui sui-save"></i></span>
            <span class="icon is-small" v-else><i class="sui sui-check"></i></span>
            <span v-if="isAuthenticated">{{ $t('save') }}</span>
            <span v-else>{{ $t('validate') }}</span>
          </button>
        </div>
      </nav>
    </form>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  name: 'Boundaries',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'serveur-info': () => import('@/components/ServeurInfo.vue')
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      hasBeenSavedOnce: false
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    allGHGI: function () {
      return this.$store.getters['admin/allGHGI']
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['commutesSubmitted']
    },
    currentYear: function () {
      return new Date().getFullYear()
    },
    availableYears: function () {
      let years = []
      let cYear = new Date().getFullYear() - 1
      let toYear = cYear - 10
      for (let i = cYear; i >= toYear; i--) {
        let year = this.allGHGI.filter(obj => parseInt(obj.year) === i)
        years.push({
          value: i,
          disabled: year.length !== 0
        })
      }
      return years
    },
    validSavedIcon: function () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    module: function () {
      return this.$store.getters['ghgi/module']
    },
    id: function () {
      return this.$store.getters['ghgi/item']['id']
    },
    year: {
      get: function () {
        return this.$store.getters['ghgi/item']['year']
      },
      set: function (year) {
        this.$store.commit('ghgi/UPDATE_YEAR', year)
        this.$store.dispatch('ghgi/forceModulesCumputation')
        this.inputChanged()
      }
    },
    nResearcher: {
      get: function () {
        return this.$store.getters['ghgi/item']['nResearcher']
      },
      set: function (nResearcher) {
        let nb = parseInt(nResearcher)
        if (isNaN(nb)) {
          nb = nResearcher
        }
        this.$store.commit('ghgi/UPDATE_NRESEARCHER', nb)
        this.inputChanged()
      }
    },
    nProfessor: {
      get: function () {
        return this.$store.getters['ghgi/item']['nProfessor']
      },
      set: function (nProfessor) {
        let nb = parseInt(nProfessor)
        if (isNaN(nb)) {
          nb = nProfessor
        }
        this.$store.commit('ghgi/UPDATE_NPROFESSOR', nb)
        this.inputChanged()
      }
    },
    nEngineer: {
      get: function () {
        return this.$store.getters['ghgi/item']['nEngineer']
      },
      set: function (nEngineer) {
        let nb = parseInt(nEngineer)
        if (isNaN(nb)) {
          nb = nEngineer
        }
        this.$store.commit('ghgi/UPDATE_NENGINEER', nb)
        this.inputChanged()
      }
    },
    nStudent: {
      get: function () {
        return this.$store.getters['ghgi/item']['nStudent']
      },
      set: function (nStudent) {
        let nb = parseInt(nStudent)
        if (isNaN(nb)) {
          nb = nStudent
        }
        this.$store.commit('ghgi/UPDATE_NSTUDENT', nb)
        this.inputChanged()
      }
    },
    budget: {
      get: function () {
        return this.$store.getters['ghgi/item']['budget']
      },
      set: function (budget) {
        this.$store.commit('ghgi/UPDATE_BUDGET', budget)
        this.inputChanged()
      }
    },
    nbTotal () {
      let total = parseInt(this.nResearcher) + parseInt(this.nProfessor)
      total += parseInt(this.nEngineer) + parseInt(this.nStudent)
      if (isNaN(total)) {
        total = 0
      }
      return (total)
    },
    isDisabled () {
      let toReturn = true
      if (this.hasBeenSavedOnce) {
        toReturn = !this.module.isModified || this.nbTotal === 0
      } else {
        toReturn = this.module.isValid || this.nbTotal === 0
      }
      return toReturn
    }
  },
  methods: {
    inputChanged () {
      if (this.hasBeenSavedOnce || this.module.isValid) {
        this.$store.commit('ghgi/ISVALID', false)
        this.$store.commit('ghgi/ERREUR', '')
        this.$store.commit('ghgi/ISMODIFIED', true)
        this.$store.commit('commutes/COMPUTED', false)
      }
    },
    validateBeforeSubmit () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          if (this.isAuthenticated) {
            const loadingComponent = this.$buefy.loading.open({
              container: null
            })
            this.$store.dispatch('ghgi/saveGHGI', {
              id: this.id,
              year: this.year,
              nResearcher: this.nResearcher,
              nProfessor: this.nProfessor,
              nEngineer: this.nEngineer,
              nStudent: this.nStudent,
              budget: this.budget
            })
              .then(data => {
                loadingComponent.close()
                this.$store.commit('ghgi/ISVALID', true)
                this.$store.commit('ghgi/ERREUR', '')
                this.$store.commit('ghgi/ISMODIFIED', false)
                this.$store.commit('commutes/COMPUTED', false)
                window.scrollTo(0, 0)
                this.$buefy.toast.open({
                  type: 'is-light',
                  message: this.$t('save-msg')
                })
                this.hasBeenSavedOnce = true
                this.id = data.id
                this.$store.dispatch('ghgi/set', this.id)
                  .then(data => {
                    this.$router.push('/ges-1point5/' + this.id).catch(() => {})
                  })
              })
              .catch((erreur) => {
                loadingComponent.close()
                this.$store.commit('ghgi/ISVALID', false)
                this.$store.commit('ghgi/ERREUR', erreur.response.data)
                this.$store.commit('ghgi/ISMODIFIED', false)
                this.$store.commit('commutes/COMPUTED', false)
              })
          } else {
            this.$store.commit('ghgi/ISVALID', true)
            this.$store.commit('ghgi/ISMODIFIED', false)
            this.$store.commit('commutes/COMPUTED', false)
            this.hasBeenSavedOnce = true
          }
        }
      })
    }
  }
}
</script>
